-- name: [CS] Shantae
-- description: Shantae, the Half Genie Hero, is now playable on SM64 Coop Deluxe!\n\n\Modpack by VioletArts
-- deluxe: true
local globalModName = "Shantae";

local E_SHANTAE_MODEL = smlua_model_util_get_id("shantae_violet_geo");
local SHANTAE_CAPMODELS = {
normal = smlua_model_util_get_id("shantae_violet_cap_geo"),
wing = smlua_model_util_get_id("shantae_violet_cap_wing_geo"),
metal = smlua_model_util_get_id("shantae_violet_cap_metal_geo"),
metalWing = smlua_model_util_get_id("shantae_violet_cap_metal_wing_geo"),
}
local SHANTAE_DESC = {"Shantae, the Half Genie Hero, has", "found her way into the Mushroom Kingdom, what", "trouble is Risky causing now?!"}
local SHANTAE_SELECTCOLOR = {r = 152, g = 25, b = 255}
local SHANTAE_PALETTE = {
[PANTS] = "FF0000",
[SHIRT] = "FF0000",
[GLOVES] = "D79577",
[SHOES] = "FF0000",
[HAIR] = "B047FF",
[SKIN] = "D79577",
[CAP] = "8800D2",
[EMBLEM] = "8800D2"
}

local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = 'ShantaeHurt.ogg',
    [CHAR_SOUND_DOH] = 'ShantaeDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'ShantaeDrowning.ogg',
    [CHAR_SOUND_DYING] = 'ShantaeDeath.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ShantaeGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'ShantaeLaugh.ogg',
    [CHAR_SOUND_HAHA_2] = 'ShantaeLaugh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ShantaeAllClear.ogg',
    [CHAR_SOUND_HOOHOO] = 'ShantaeJumping2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'ShantaeNo.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'ShantaeLetsGo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ShantaeBurning.ogg',
    [CHAR_SOUND_OOOF] = 'ShantaeOof.ogg',
    [CHAR_SOUND_OOOF2] = 'ShantaeOof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ShantaeYah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'ShantaeHah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'ShantaeHoo.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'ShantaeKill.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ShantaeFalling.ogg',
    [CHAR_SOUND_WAH2] = 'ShantaeYah.ogg',
    [CHAR_SOUND_WHOA] = 'ShantaeClimb.ogg',
    [CHAR_SOUND_YAHOO] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'ShantaeJumping1.ogg',
    [CHAR_SOUND_YAWNING] = 'ShantaeYawn.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'ShantaeLetsGo.ogg',
    [CHAR_SOUND_EEUH] = 'ShantaeLedgeGrab.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'ShantaePantingCold.ogg',
}

if _G.charSelectExists and SM64COOPDX_VERSION then
    local curVers = _G.charSelect.version_get();
     if not tonumber(curVers) then
        curVers = string.gsub(curVers, "[%a%s_()!?:,@#-]+", "");
                
        curVers = curVers:gsub("%.", "X", 1):gsub("%.", ""):gsub("X", ".");
    end
    curVers = tonumber(curVers);

table.insert(SHANTAE_DESC, "");
table.insert(SHANTAE_DESC, "Model by VioletArts");

local charNum = _G.charSelect.character_add("Shantae", SHANTAE_DESC, "VioletArts", SHANTAE_SELECTCOLOR, E_SHANTAE_MODEL, CT_MARIO, get_texture_info("shantae_violet_icon"));
_G.charSelect.character_add_caps(E_SHANTAE_MODEL, CHARA_CAPMODELS);

if curVers >= 1.8 then -- adds palette preset if 1.8 or above
_G.charSelect.character_add_palette_preset(E_SHANTAE_MODEL, SHANTAE_PALETTE);
end
--[[if curVers > 1.8 then -- adds custom health meter if above 1.8
_G.charSelect.character_add_health_meter(charNum, healthHUDTex);
end]]

_G.charSelect.character_add_voice(E_SHANTAE_MODEL, VOICETABLE_CHAR)
hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end)
hook_event(HOOK_MARIO_UPDATE, function (m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end)
else
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end